<?php

class Label {

    var $desc;
    var $widget;
    var $class;
    var $breakLine = false;

    function Label(&$widget, $desc, $class = NULL, $br=false) {
        $this->desc      =  $desc;
        $this->widget    =& $widget;
        $this->class     =  $class;
        $this->breakLine =  $br;
        assert(!is_null($widget));
        assert(!is_null($widget->htmlid));
    }

    // Return HTML code
    function htmlCode() {
        $res = '';
        if(!$this->widget->usesLabel) {
            $res .= '<label for="'.htmlspecialchars($this->widget->htmlid).'"';
            if(!is_null($this->class))
                $res .= ' class="'.htmlspecialchars($this->class).'"';
            $res .= '>';
        } elseif (!is_null($this->class)) {
            $res .= '<span class="'.htmlspecialchars($this->class).'">';
        }
        $res .= htmlspecialchars($this->desc);
        if(!$this->widget->usesLabel) {
            $res .= '</label>';
        } elseif(!is_null($this->class)) {
            $res .= "</span>";
        }
        $res .= $this->breakLine ? '<br>' : ' ';
        $res .= $this->widget->htmlAllCode();
        if(!is_null($this->widget->afterLabel)){
            $res .= call_user_func($this->widget->afterLabel);
        }
        return $res;
    }

    // print HTML code and validation error if there is
    function printHtmlCode() {
        print $this->htmlCode();
        print "\n";
    }
}

?>