<?php

include_once(dirname(__FILE__).'/widget-multichoice.php');

class WidgetCheckboxes extends WidgetMultiChoice {

    var $usesList  = false;
    var $usesLabel = true;

    // Constructor
    function WidgetCheckboxes($name, $htmlid, $form_id=NULL, $dbid=NULL) {
        parent::WidgetMultiChoice($name, $htmlid, $form_id, $dbid);
        $this->usesLabel = true;
        $this->usesList  = false;
        if(!is_array($this->defaultValue)) $this->defaultValue = array();
    }

    // Return HTML code
    function htmlCode() {
        $res = '';
        if($this->usesList){
            $res .= "<ul class=\"form\">\n";
        }
        foreach($this->itemNames as $name){
            $desc = $this->itemDescriptions[$name];
            $res .= $this->usesList ? "\t<li>" : "\t";
            $res .= '<label for="'.htmlspecialchars($this->htmlid.".$name").'">'
                 .  '<input type="checkbox"'
                 .  ' name="'.htmlspecialchars($this->name).'[]"'
                 .  ' id="'.htmlspecialchars($this->htmlid.".$name").'"'
                 .  ' value="'.htmlspecialchars($name).'"';
            if(in_array($name, $this->defaultValue, true)){
                $res .= ' checked="checked"';
            }
            $res .= '>&nbsp;'.htmlspecialchars($desc).'</label>';
            $res .= $this->usesList ? "</li>\n" : "\n";
        }
        if($this->usesList){
            $res .= "</ul>";
        }
        return $res;
    }

    // Validate GET/POST variable
    // Return NULL if validation fails. In that case it set
    // $this->validationError to a message explaining why it failed.
    // On success it returns the converted data and $this->validationError is
    // cleared to NULL
    /*
    function validate($data){
        $this->validationError = NULL;
        // TODO
        if(!is_array($data)){
            $data = array();
        }
        foreach($data as $d){
            if(!in_array($d, $this->itemNames, true)){
                $this->validationError = "Value $d not allowed";
                return NULL;
            }
        }
        return $data;
    }
    */

    // Prepare the data to be stored in the database
    function serializeData($data){
        return serialize($data);
    }

    // Inverse of serializeData()
    function unserializeData($data){
        return is_string($data) ? unserialize($data) : $data;
    }

    // Set the default value
    function setDefaultValue($val=NULL){
        parent::setDefaultValue($val=NULL);
        if(!is_array($this->defaultValue)) $this->defaultValue = array();
    }

}

?>