<?php

include_once(dirname(__FILE__).'/widget-list.php');
include_once(dirname(__FILE__).'/bdd-widget-insert-element.php');
include_once(dirname(__FILE__).'/bdd-widget-get-elements.php');

class WidgetDbList extends WidgetList {

    var $widgetType = 'WidgetDbList';

    var $addAdditions = false;

    var $otherGroup = NULL;

    // Constructor
    // On failure (database error) an exception is thrown.
    function WidgetDbList($name, $htmlid=NULL, $form_id=NULL, $dbid=NULL) {
        parent::WidgetList($name, $htmlid, $form_id, $dbid);
        $error = NULL;
        $values = bdd_widget_get_elements($this->widgetType, $this->dbid, $error);
        if(is_null($error)) {
            foreach($values as $v){
                //print "Load {$v['value']}<br>\n";
                $arr = @unserialize($v['desc']);
                list($desc, $group) = $arr ? $arr : array($v['desc'], NULL);
                $this->addItem($v['value'], $desc, $group, false);
            }
        } else {
            throw new Exception($error);
        }
    }

    function addItem($name, $description=NULL, $optgroup=NULL, $addDatabase=false) {
        if(is_null($description)) $description=$name;
        parent::addItem($name, $description, $optgroup);
        if($addDatabase){
            bdd_widget_insert_element($this->widgetType, $this->dbid,
                $name, serialize(array($description, $optgroup)), $error);
            if($error){
                throw $error;
            }
        }
    }

    function addNewItem($name, $description, $optgroup=NULL, $addDatabase=true) {
        //print "Add $name<br>\n";
        if(!in_array($name, $this->itemNames, true)){
            $this->addItem($name, $description, $optgroup, $addDatabase);
        }
    }

    function addOtherChoice($w, $desc='Other ...', $val='**OTHER**', $optgroup=NULL){
        if(is_null($optgroup)) $optgroup=$val;
        $this->otherGroup = $optgroup;
        return parent::addOtherChoice($w, $desc, $val);
    }

    function validate($data){
        $res = parent::validate($data);
        //print "Validate $data<br>\n";
        if($this->allowOther) $this->addNewItem($res, $res, $this->otherGroup);
        return $res;
    }

}

?>