<?php

include_once(dirname(__FILE__).'/widget.php');

class WidgetMultiChoice extends Widget {

    var $itemDescriptions;  // indexed by item name
    var $itemNames;         // numeric index
    var $allowNone = true;

    // Constructor
    function WidgetMultiChoice($name, $htmlid, $form_id=NULL, $dbid=NULL) {
        parent::Widget($name, $htmlid, $form_id, $dbid);
        $this->itemDescriptions = array();
        $this->itemNames = array();
        $this->allowNone = true;
    }

    function addItem($name, $description=NULL) {
        if(is_null($description)) $description=$name;
        $this->itemNames[] = $name;
        $this->itemDescriptions[$name] = $description;
    }

    // Validate GET/POST variable
    // Return NULL if validation fails. In that case it set
    // $this->validationError to a message explaining why it failed.
    // On success it returns the converted data and $this->validationError is
    // cleared to NULL
    function validate($data){
        $this->validationError = NULL;
        if(is_array($data)) {
            foreach($data as $d){
                if(!in_array($d, $this->itemNames, true)){
                    $this->validationError = "Value $d not allowed";
                    return NULL;
                }
            }
        } elseif(!in_array($data, $this->itemNames, true)) {
            if($this->allowNone){
                return false;
            } else {
                $this->validationError = "Value not in range";
                return NULL;
            }
        }
        return $data;
    }
}

?>