<?php

include_once(dirname(__FILE__).'/widget-multichoice.php');

class WidgetRadios extends WidgetMultiChoice {

    var $usesList  = false;
    var $usesLabel = true;

    // Constructor
    function WidgetRadios($name, $htmlid, $form_id=NULL, $dbid=NULL) {
        parent::WidgetMultiChoice($name, $htmlid, $form_id, $dbid);
        $this->usesLabel = true;
        $this->usesList  = false;
    }

    // Return HTML code
    function htmlCode() {
        $res = '';
        if($this->usesList){
            $res .= "<ul class=\"form\">\n";
        }
        foreach($this->itemNames as $name){
            $desc = $this->itemDescriptions[$name];
            $res .= $this->usesList ? "\t<li>" : "\t";
            $res .= '<label for="'.htmlspecialchars($this->htmlid.".$name").'">'
                 .  '<input type="radio"'
                 .  ' name="'.htmlspecialchars($this->name).'"'
                 .  ' id="'.htmlspecialchars($this->htmlid.".$name").'"'
                 .  ' value="'.htmlspecialchars($name).'"';
            if($this->defaultValue === $name){
                $res .= ' checked="checked"';
            }
            $res .= '>&nbsp;'.htmlspecialchars($desc).'</label>';
            $res .= $this->usesList ? "</li>\n" : "\n";
        }
        if($this->usesList){
            $res .= "</ul>";
        }
        return $res;
    }

    // Validate GET/POST variable
    // Return NULL if validation fails. In that case it set
    // $this->validationError to a message explaining why it failed.
    // On success it returns the converted data and $this->validationError is
    // cleared to NULL
    /*
    function validate($data){
        $this->validationError = NULL;
        if(!in_array($data, $this->itemNames, true)){
            if($this->allowNone){
                return false;
            } else {
                $this->validationError = "Value not in range";
                return NULL;
            }
        } else {
            return $data;
        }
    }
    */
}

?>